VERSION HISTORY:
Audica 1	(08-04-19)
Audica 2	(08-04-20)
Audica 3	(08-04-21)
Audica 4 (pre)	(09-05-03)
Audica 4 dev	(09-08-20)
Audica 4 dev 3	(09-09-10)
Audica 4 dev 4	(09-09-13)
Audica 4 dev 5	(09-09-22)

(09-09-24)
-Поддержка многоканальных файлов.
-Изменения визуализации.
-Циклическая прокрутка списков клавишами.
(09-09-26)
-Поддержка Unicode в Drag'n'Drop операциях.

Audica 4 dev 6	(09-09-26)

(09-09-26)
-Плавающая ширина визуализации
(09-09-27)
-FIX: mouseUp для прогресс-бара не происходит, если нажать Alt+Tab
Проверка GetCapture<>hwnd на mousemove(button=1), т.к. при альт-таб кэпче снимается и вызывается mousemove.
-FIX: Стереть hs-URL и отключить ласт.фм - Connected не исчезает
-FIX: плейлист lst_0.txt загружается даже при отсутствии options.ini
-FIX: каждая строка в плейлистах увеличивается на 1 байт после сохранении
Ошибка в midFromArr, при чтении строк их длина увеличивалась на 1 байт.
-FIX: ошибка при чтении плейлистов в ReadBytesFromFile и getItemFromArr
Из файла считывалось на 1 байт больше, это скрывало ошибки в getItemFromArr.
(09-09-28)
-Сохранение кеша прослушанных треков на случай, если не удалось сделать скробблинг до закрытия программы
-Окно About
(09-09-29)
-Авто-подбор ширины колонок в плейлистах, убраны заголовки
-Перемещение треков между плейлистами перетаскиванием
(09-09-30)
-Копирование путей к файлам из плейлистов по Ctrl+C (ANSI)
(09-10-01)
-Выделение следующего трека в плейлисте
-Классы отображения и хранения плейлистов объединены в один.
(09-10-03)
-Custom-выделение в плейлисте, не отображается фокус-рамка
(09-10-04)
-Отображение номера выделенного трека и общего кол-ва треков в контекстном меню
-Меню быстрого поиска в плейлисте текущего и следующего треков
(09-10-05)
-FIX: выделение предыдущего играемого трека не снималось, например, если он в другом листе
(09-10-06)
-FIX: Поддержка libre.fm (BAD TIMESTAMP)
Неверно подсчитывалось время в UTC
(09-10-09)
-FIX: ошибка при загрузке неверного плейлист-файла
Из-за попытки считать отрицательное число байт
-Хранение имен плейлистов непосредственно в плейлист-файлах
-Удаление неиспользуемых плейлист-файлов
-Плейлист сохраняет адрес веб-сайта потока
(09-10-13)
-Специальный плейлист - Корзина. Хранит до закрытия программы удаленные из других плейлистов треки.
(09-10-18)
-Мигание светодиодами на PS/2 клавиатуре в такт музыке

Audica 4 dev 7	(09-10-18)

(09-10-20)
-Изменено управление табами. DoubleClk - создать, MiddleClk - удалить, RightClick - меню: удалить, переименовать.
(09-10-22)
-Поддержка Unicode при добавлении файлов через диалог открытия
-Увеличена скорость копирования путей к файлам в буфер (~28 раз). Добавлена поддержка Unicode.
(09-10-27)
-FIX: проблемы с реакцией на нажатия клавиш во время мигания диодами.
Перестаёт мигать при любой нажатой клавише (хук клавиатуры).
-Можно установить параметры эквалайзера при отсутствии играемого трека.
(09-10-31)
-OwnerData в плейлистах.
(09-11-01)
-Сохранение текущего трека для каждого списка в файл плейлиста.
-Запуск последнего трека после загрузки программы (опционально).
(09-11-10)
-Изменения дизайна вкладок.
(09-11-12)
-FIX: Поправлена позиция отрисовки оставшегося времени.
(09-11-15)
-FIX: верное отображение символа "&" в информации о треке
(09-11-22)
-FIX: Захват курсора при перетаскивании элементов
-Скролл списка вверх/вниз при перетаскивании элементов
(09-11-26)
-FIX: Если в плейлисте нет текущего трека, то при старте Audica будет запущен следующий.
-Сортировка плейлистов мышью.
(09-11-27)
-Универсальная кнопка: Play (не проигрывается), Pause (проигрывается), Stop (проигрывается поток).
(09-11-29)
-Изменение громкости с помощью SHift+Wheel
-Клик правой кнопкой по универсальной кнопке - Stop для потоков и локальных файлов.

Audica 4	(09-11-29)

(09-11-29)
-FIX: Поддержка drag'n'drop папок с Unicode именами
-FIX: Поддержка Unicode в командной строке (напр. открытие файлов через Проводник)
(09-12-03)
-Поддержка обложек с помощью FreeImage. Обложки загружаются из ID3V2 тегов или файлов cover на диске.
Допускаются имена cover.jpg, cover.jpeg, cover.png, cover.gif, cover.bmp
-Автоматическая установка фокуса на плейлист при прокрутке колесом мыши (без Shift).
-Управление громкостью колесом мыши без Shift, если фокус в Audica и курсор за пределами плейлиста.
(09-12-07)
-Настоящий OwnerData в плейлистах.
Предыдущий был эмуляцией:)
-Отображение названия альбома и номера трека в плейлисте
-FIX: Обложка из ID3V2 читалась не полностью.
-Текущий трек виден в плейлисте сразу при запуске плеера.
(09-12-08)
-Сортировка треков по Названию, Исполнителю, Альбом и Номеру трека, Пути
-Улучшено качество рисования при уменьшении размера обложки
(09-12-10)
-Поиск по плейлисту (ANSI)
-Если URL введен без указания протокола, то автоматически подставляется "http://".
-FIX: загрузка трека прекращалась при попытке считать неверный фрейм APIC из ID3V2.
(09-12-11)
-Улучшено перетаскивание внутри плейлиста.
(09-12-12)
-Увеличение картинки при нажатии на обложку.
-В качестве обложек поддерживаются файлы с именами "*AlbumArt*".
(09-12-13)
-Запуск воспроизведения кнопкой Play/Pause на клавиатуре
(09-12-17)
-Хук клавиатуры и мыши вынесен в инструмент hooktool.
Избавляет от необходимости снимать хук на длительных операциях.
-Надпись "AUDICA" при отсутствии играемого трека.
(09-12-19)
-Использование Dictionary вместо Collection для хранения треков.
Ускоряет сортировку в ~1.5-2 раза.
-Вставка элементов в список при перетаскивании из Проводника.
Ранее они добавлялись в конец списка.
-FIX: если запустить трек в последнем плейлисте и закрыть его, то на следующем треке происходит падение.
Выполнялось обращение к списку с неверным индексом.
-Небольшое ускорение сортировки за счёт использования числовых ключей.
(09-12-29)
-FIX: Поправка играемого трека при вставке/удалении элементов.
(09-12-30)
-Всплывающие подсказки для частично видимых полей в плейлистах.
-Кнопка дальнейшего поиска (>) заменена клавишей Enter или F3.
(10-01-02)
-Уменьшено мерцание при изменении ширины плейлиста.
-FIX: Верное выделение кнопок R и D при открытии файла через Проводник.
(10-01-04)
-Поддержка Unicode в поле поиска по плейлисту.
-FIX: При переключении треков и открытом диалоге добавления файлов могло произойти падение.
Диалог изменяет текущий каталог, поэтому программа не находит FreeImage (нужно загружать его с помощью LoadLibrary).
-Копирование треков между плейлистами при удержании Ctrl.
(10-01-05)
-Окно с информацией о композиции и громкости (интерфейс требует доработки).
Отображается на 3с при запуске трека, на 1с при изменении громкости, если фокус вне программы.
(10-01-10)
-Переписан код работы с удаленными источниками (добавлена пребуферизация и пр.)
(10-01-11)
-Получение OGG тегов интернет-потоков.
(10-01-12)
-FIX: После падения программы и последующего запуска, hooktool не подключался к основной программе.
(10-01-13)
-Увеличена стабильность при подключении к интернет-потоку за счет блокирования программы.
-Визуализация - управление цветом Aero (если доступно) в такт музыке.
-FIX: Верные пропорции обложек в окне информации.
-FIX: Ошибка при запуске из панели Windows 7 - сбой инициализации BASS.
В качестве главного окна передавать BASS информационное окно, а не 0.

Audica 5 rev.1	(10-01-13)

(10-01-16)
-FIX: При удалении радио-потока из плейлиста происходило падение при изменении тегов.
Попытка обновления трека с неверным индексом -1.
-Возможность загрузки локальных файлов на файл-хостинги.
(10-01-17)
-FIX: Прекращалась отрисовка главного окна.
Обработка WM_PAINT поля поиска через DefWindowProc. Тоже для списков, чтобы верно рисовались скролл-бары.
-Отображение обложек на панели задач (Windows 7).
(10-01-22)
-Отображение прогресса и состояния трека, а также состояния подключения к потоку на панели задач (Windows 7).
-Кнопки Prev/Universal/Next на панели задач (Windows 7).
-FIX: При запуске плеера с переданным файлом, запускается предыдущий трек, если установлен флаг 'Play on start'.
Игнорировать флаг, если передается параметр.
-FIX: Надпись на вкладке больше не выходит за её пределы.
(10-01-25)
-FIX: Нет 0.5с задержки отрисовки времени на полосе прокрутки при запуске трека.
-Компактный режим: в главном окне убираются некоторые элементы, если его ширина меньше 354 пикселей.
-FIX: При открытии окна добавления файлов прекращалась перерисовка плейлиста.
-Отображение обложек вместо превью окна (Windows 7).
(10-01-27)
-Отображения процесса поиска файлов при добавлении больших директорий.
-Отображение общего времени плейлиста и количества треков в главном окне.
-FIX: Падение при смене тегов радио, если был закрыт плейлист содержащий этот поток.
(10-01-28)
-Функция предпрослушивания локальных файлов.
-FIX: Теперь нельзя открывать более одного диалога добавления файлов.
-FIX: Падение на треках длиной менее секунды.
Длина трека хранилась в целочисленной форме и могла округляться до нуля.
-Увеличена точность навигации внутри трека, зависит от ширины полосы прокрутки.
Ранее точность перемотки курсором была 1 сек или ниже.
(10-01-30)
-Отображение времени под курсором на полосе прокрутки.
(10-02-01)
-Добавление URL теперь выполняется в окне добавления файлов.
-Ведется история 10 ранее введенных URL адресов.
(10-02-02)
-FIX: Нельзя покинуть программу пока открыт диалог добавления файлов.
Иначе Audica остается в памяти и после закрытия диалога.
-Поддержка открытия плейлистов форматов M3U, M3U8 и PLS.
(10-02-03)
-Поддержка многотрековых Ogg файлов (chained logical bitstreams).
-FIX: Исправлено regexp выражение для отличия интернет-потоков от локальных файлов.
Путь к файлу мог распознаться как интернет-поток.
-FIX: При сортировке плейлистов флаг Default не перемещается на новый индекс.
(10-02-04)
-FIX: Выделение играемого трека снималось не только при его удалении, но и при копировании.
-FIX: Более точный выбор вкладки нажатием мышы, особенно при небольшой ширине окна.
-Поиск в плейлисте выполняется также и по имени файла.
(10-02-05)
-Функция сохранения треков из chained Ogg файлов в виде отдельных файлов.
(10-02-06)
-В поле времени для интернет-потоков отображается "i".

Audica 6	(10-02-06)


TODO:
-Фоновое сканирование тегов
-Регистрация типов файлов
-Эквалайзер
-Улучшение консоли: фильтр по типам событий, больший выбор цветов
?Название радиостанции на русском отображается неверно
Использовать ANSI. Полностью ли верное решение, неизвестно.
-Отображение реального битрейта интернет-потоков
-Загрузка лирики
?Drag-n-Drop файлов из программы.
-FIX: Отображение окна с информацией о треке при длинных названиях.
-Цветовая схема
-Хоткеи Shift+Вправо\Влево, Shift+Pause
-Запись интернет-потоков.
-Скробблинг композиций из интернет-потоков.
?Обложки ogg интернет-потоков
-FIX: Отключение радио. Смена фокуса?
-Улучшенная работа с обложками - ускорение отрисовки, удобство написания кода.
-Сохранение плейлистов
-Переделать чтение параметров командной строки
?Отображение в плейлисте только названия станции, без тегов композиции.
-Поиск исполнителя в интернете.
-Вставка файлов по Ctrl+V (? и по адресу файла)
